<?php

if(!defined('ABSPATH')){exit('Premission Denied');}

if(!class_exists('Athena_Fields')){

	class Athena_Fields{

		private $_settings;


		public function __construct($options, $saved = null, $settings = null){

			if($settings !== null){
				$this->_settings = $settings;
			}

			$call = $options['type'];

			$this->$call($options, $saved);

		}


		private function header( $opt ){
			?>
            <h2><?php echo $opt['name']; ?></h2>
			<?php
		}
		private function date_box( $opt, $saved ){
			global $post;
			$timestamp = get_post_meta($post->ID, $opt['id'] . '_timestamp', true);
			?>
            <div class="athena-element-hold">
                <div class="athena-title"><?php echo $opt['name']; ?></div>
                <div class="athena-desc"><?php echo $opt['desc']; ?></div>
                <input type="hidden" name="<?php echo $opt['id']; ?>_timestamp" value="<?php echo !empty($timestamp) ? $timestamp : ''; ?>" class="athena-profile-datetime-string" data-utc="<?php echo strtotime($saved); ?>">
                <input type="text" name="<?php echo $opt['id']; ?>" value="<?php echo $saved; ?>" class="athena-profile-datetime-hold form-control">
                <div class="athena-profile-datetime"></div>

            </div>
			<?php
		}//end date_box method

		private function future_date($opt, $saved){
			?>
            <div class="athena-element-hold">
                <div class="athena-title"><?php echo $opt['name']; ?></div>
                <div class="athena-desc"><?php echo $opt['desc']; ?></div>
                <div class="row">
                    <div class="col-sm-4">
                        <select name="<?php echo $opt['id']; ?>[count]">
							<?php
							for($i = 1; $i <= 12; $i++){
								echo '<option value="'.$i.'" ';

								if($saved['count'] == $i){
									echo 'selected="selected"';
								}

								echo '>'.$i.'</option>';
							}
							?>
                        </select>
                    </div>
                    <div class="col-sm-8">

						<?php

						if($opt['times'] === 'day'){

							$type = array('d' => 'Day(s)', 'w' => 'Week(s)', 'm' => 'Month(s)');

						}else if($opt['times'] === 'hour'){

							$type = array('h' => 'Hour(s)', 'd' => 'Day(s)');

						}

						?>

                        <select name="<?php echo $opt['id']; ?>[type]">
							<?php
							foreach($type as $key => $value){
								echo '<option value="'.$key.'"';

								if($saved['type'] == $key){
									echo 'selected="selected"';
								}

								echo '>'.$value.'</option>';
							}
							?>
                        </select>
                    </div>
                </div>
            </div>

			<?php
		}
		private function text( $opt, $saved ){

			$this->activate_check( $opt );
			?>
            <div class="athena-title"><?php echo $opt['name']; ?></div>
            <div class="athena-desc"><?php echo $opt['desc']; ?></div>
            <input type="text" name="<?php echo $opt['id']; ?>" value="<?php echo $saved; ?>" class="form-control" <?php echo ($opt['required'])? 'data-required="1"' : ''; ?> <?php echo isset($opt['max'])? 'maxlength="'. $opt['max'] .'"': ''; ?>>

			<?php

			if(isset($opt['display']) && $opt['display'] === true){

				echo '<p>('.date($saved, current_time('timestamp')) .')</p>';
			}

			if(isset($opt['legend'])){
				echo $opt['legend'];
			}
			?>

            </div>
			<?php
		}//end text method

		private function textarea( $opt, $saved ){

			$this->activate_check( $opt );
			?>
            <div class="athena-title"><?php echo $opt['name']; ?></div>
            <div class="athena-desc"><?php echo $opt['desc']; ?></div>
			<?php wp_editor( $saved, $opt['id'], array('wpautop' => false)); ?>

			<?php
			if(isset($opt['legend'])){
				echo $opt['legend'];
			}
			?>
            </div>
			<?php

		}//end textarea method

		private function checkbox( $opt, $saved ){

			$this->activate_check( $opt );
			?>
            <div class="athena-title"><?php echo $opt['name']; ?></div>
            <div class="athena-desc"><?php echo $opt['desc']; ?></div>
			<?php if(isset($saved) && $saved == true){$checked = 'checked';}else{$checked = '';} ?>
            <input type="checkbox" value="1" name="<?php echo $opt['id']; ?>" id="<?php echo $opt['id']; ?>" class="athena-checkbox" <?php echo $checked; ?>>
            <label for="<?php echo $opt['id']; ?>"></label>

            </div>
			<?php

		}//end checkbox method

		private function category( $opt, $saved ){

			$this->activate_check( $opt );
			$args = array(
				'hide_empty' => false
			);
			$categories = get_categories( $args );
			?>

            <div class="athena-title"><?php echo $opt['name']; ?></div>
            <div class="athena-desc"><?php echo $opt['desc']; ?></div>
            <select name="<?php echo $opt['id']; ?>[]" class="select-two" multiple style="width:100%; margin-top:10px;" <?php echo ($opt['required'])? 'data-required="1"' : ''; ?>>
				<?php
				foreach($categories as $key => $value){

					echo '<option value="'.$value->term_id.'"';

					if(!empty($saved) && ($key = array_search($value->term_id, $saved)) !== false){

						echo 'selected="selected"';

					}

					echo '>'.$value->name.'</option>';

				}
				?>
            </select>

            </div>
			<?php

		}//end category method

		private function select( $opt, $saved ){

			$this->activate_check( $opt );
			?>
            <div class="athena-title"><?php echo $opt['name']; ?></div>
            <div class="athena-desc"><?php echo $opt['desc']; ?></div>
            <select name="<?php echo $opt['id']; ?>" <?php echo (isset($opt['onChange']) && $opt['onChange'] === true)? 'class="'.$opt['class'].'"' : ''; ?> <?php echo ($opt['required'])? 'data-required="1"' : ''; ?>>
				<?php
				foreach($opt['options'] as $key => $name){

					echo '<option value="'.$key.'"';

					if($key === $saved){
						echo 'selected="selected"';
					}

					echo '>'. $name .'</option>';

				}
				?>
            </select>
            </div>
			<?php
			if($opt['onChange']){
				$this->onChange( $opt );
			}
		}//end select method

		private function cron( $opt ){

			$cron_jobs = get_option('cron');
			?>
            <br>
            <div class="athena-element-hold">
				<?php
				$profiles = array();
				$posts = array();
				foreach($cron_jobs as $key => $value){

					if(is_array($value)){

						foreach($value as $k => $i){

							if(strpos($k, 'athena_profile') !== false && ($post_id = strrchr($k, '_')) !== false){
								$post_id = substr($post_id, 1);
								$profiles[$key] = get_post( $post_id );

							}


							if(strpos($k, 'athena_post') !== false && ($post_id = strrchr($k, '_')) !== false){
								$post_id = substr($post_id, 1);
								$posts[$key] = get_post( $post_id );

							}

						}//end array foreach loop

					}//end check if value is an array

				}//end of foreach look

				if(!empty($profiles) || !empty($posts)){

					if(!empty($profiles)){

						echo '<h2>Profile Scheduled</h2>';
						ksort($profiles, SORT_NUMERIC);

						foreach($profiles as $t => $v){
							$date = new DateTime();
							$date->setTimestamp($t);

							$timezone = get_option('timezone_string');
							$timezone = !empty($timezone) ? $timezone : get_option('gmt_offset');

							date_timezone_set($date, timezone_open($timezone));

							echo '<h3>' . $v->post_title . '</h3>';
							echo 'Runs: '. date_format($date, $this->_settings['date_time_format']);
						}
					}

					if(!empty($posts)){
						echo '<h2>Posts Scheduled</h2>';
						ksort($posts, SORT_NUMERIC);

						foreach($posts as $t => $v){

							$date = new DateTime();
							$date->setTimestamp($t);

							$timezone = get_option('timezone_string');
							$alt_timezone = get_option('gmt_offset');
							$timezone = !empty($timezone) ? $timezone : !empty($alt_timezone) ? $alt_timezone : date_default_timezone_get() ;

							date_timezone_set($date, timezone_open($timezone));

							echo '<h3>' . $v->post_title . '</h3>';
							echo 'Runs: '. date_format($date, $this->_settings['date_time_format']);
						}
					}

				}else{
					echo '<p>There are no expirations scheduled</p>';
				}

				?>
            </div>
			<?php
		}//end choice method

		private function post_meta( $opt, $saved){
			global $post_type;


			$args = array(
				'post_type' => 'athenaprofile',
				'posts_per_page' => -1,
				'meta_key' => '_post_expiration_timestamp',
				'meta_value' => current_time('timestamp', 1),
				'meta_compare' => '>'

			);
			$profiles = get_posts( $args );

			?>			<div class="athena-post_meta-hold">
				<?php if(isset($saved['enabled']) && $saved['enabled'] == true){$checked = 'checked';}else{$checked = '';} ?>
                <div class="athena-enable"><span>Enable</span> <input type="checkbox" name="<?php echo $opt['id']; ?>[enabled]" value="1" <?php echo $checked; ?>></div>
                <div class="athena-profile"><span>Profile</span>
                    <select name="<?php echo $opt['id']; ?>[profile]" class="form-control">
                        <option value="">Select Profile</option>
						<?php
						foreach( $profiles as $value ){

							echo '<option value="'. $value->ID .'"';

							if(isset($saved['profile']) && $value->ID == $saved['profile']){

								echo ' selected="selected"';

							}

							echo '>'. $value->post_title .'</option>';

						}
						?>
                    </select>
                </div>
                <div class="athena-sep-title">Or</div>

				<?php

				$count = $this->_settings['future_date_'.$post_type]['count'];
				$type = athena_date_time( $count );

				$time_string = strtotime('+'.$count . ' ' .$type[$this->_settings['future_date_'.$post_type]['type']]);

				?>
                <div class="athena-date-picker">
                    <input type="hidden" name="<?php echo $opt['id']; ?>[timestamp]" value="<?php echo isset($saved['timestamp'])? $saved['timestamp'] : $time_string; ?>" class="athena-post-timestamp">

                    <span>Date/Time</span>
                    <div class="form-group">
                        <div class="input-group date" id="athena-post-datepicker">
                            <input type='text' name="<?php echo $opt['id']; ?>[time]" class="form-control" />
                            <span class="input-group-addon">
								<i class="fa fa-calendar" aria-hidden="true"></i>
							</span>
                        </div>
                    </div>
                </div>
            </div>
			<?php
		}//end profile_list method


		private function activate_check( $opt ){

			if(isset($opt['activate'])){

				$class = ' athena-hide';
				$data = 'data-select="'.$opt['select'].'"';
				$activate = 'data-activate="'.$opt['activate'].'"';
				echo '<div class="athena-element-hold'. $class . '"' . $data . ' ' . $activate .'>';
				return;

			}else{

				echo '<div class="athena-element-hold">';
				return;

			}

		}

		private function onChange( $opt ){
			?>
            <script>
                jQuery(document).ready(function(){
                    var mainEl = jQuery('.<?php echo $opt['class']; ?>');
                    var initVal = mainEl.val();
                    var current = jQuery('div[data-select="'+initVal+'"]');
                    var currentIn = current.find('input, select, textarea');
                    var isRequired = currentIn.data('required');
                    isRequired = Number(isRequired);

                    current.show();

                    if(isRequired){
                        currentIn.attr('required', 'required');
                    }

                    mainEl.change(function(){

                        var valData = jQuery(this).val();
                        var hidden = jQuery('div[data-activate="<?php echo $opt['class']; ?>"]');

                        hidden.each(function(){

                            var element = jQuery(this).data('select');

                            if(valData === element){
                                hidden.slideUp(300);
                                jQuery(this).slideDown(300);

                                var input = jQuery(this).find('input, select, textarea');
                                var required = input.data('required');
                                required = Number(required);

                                if(required){
                                    input.attr('required', 'required');
                                }

                                return false;
                            }else{
                                hidden.slideUp(300);
                                var input = jQuery(this).find('input, select, textarea');

                                input.removeAttr('required');
                            }

                        });

                    });

                });
            </script>
			<?php
		}//end onChange method



	}//end class Athena_Fields

}//end class_exists conditional